<?php
defined('_JEXEC') or die;

/* Файл-скрипт для компонента */
class com_KartaRFInstallerScript
{
	/* Метод для установки компонента */
	function install($parent) 
	{
		$parent->getParent()->setRedirectURL('index.php?option=com_kartarf');
	}

	/* Метод для удаления компонента */
	function uninstall($parent) 
	{
		echo '<p>' . JText::_('COM_KARTARF_UNINSTALL_TEXT') . '</p>';
	}

	/* Метод для обновления компонента */
	function update($parent) 
	{
		echo '<p>' . JText::sprintf('COM_KARTARF_UPDATE_TEXT', $parent->get('manifest')->version) . '</p>';
	}

	/* Метод, который исполняется до install/update/uninstall */
	function preflight($type, $parent) 
	{
		echo '<p>' . JText::_('COM_KARTARF_PREFLIGHT_' . $type . '_TEXT') . '</p>';
	}

	/* Метод, который исполняется после install/update/uninstall */
	function postflight($type, $parent) 
	{
		echo '<p>' . JText::_('COM_KARTARF_POSTFLIGHT_' . $type . '_TEXT') . '</p>';
	}
}