﻿package  {
	
	import flash.display.*;
	import flash.events.*;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.geom.ColorTransform;
	import flash.text.TextField;
	import flash.utils.Timer;
	import doc_as.*;

	public class Main extends MovieClip {
		
		public static var par:DannyeFlashVars;               /* Параметры полученные из PHP-скрипта в виде объекта класса --- */
		public static var arrRg:Array;                       /* Клипы-субъекты РФ --- */
		public static var arrGr:Array;                       /* Клипы-города РФ --- */
		public static var subRF:Array;                       /* Список названий субъектов РФ (из класса DannyeProject) --- */
		public static var cenRF:Array;                       /* Список названий центров суб.РФ (из класса DannyeProject) --- */
		public static var krdGr:Array;                       /* Коорд.выв.текст.поля-центра суб.РФ (из класса DannyeProject) --- */
		public static var infRg:Array;                       /* Данн.по суб.РФ получ.из XML-док.БЕЗ Мск и Спб --- */
		public static var vnFil:Array;                       /* Клипы-кнопки загружаемых внешних файлов --- */
		
		private var blHg:Number;                             /* Принимает высоту блока-инфо для сворач.и разворач. --- */
		private var infR2:Array;                             /* Данн.по суб.РФ получ.из XML-док.по регионам Мск и Спб --- */
		private var arMSP:Array;                             /* Данные по Московским и С-Петербургским субъектам РФ --- */
		private var arObj:Array;                             /* Объекты собранные для удобства передачи в функции --- */
		private var txtG:TextField;                          /* Текст.поле назв.города-адм.центра(НЕ Мск и СПб) --- */ 
		private var txtG2:TextField;                         /* Текст.поле назв.города-адм.центра(Мск и СПб) --- */
		private var loadXML:URLLoader;                       /* Объект опред в функц-констр Main и использ.в zagruzXML --- */
		private var zagr:Loader;                             /* Фон карты-внешний файл --- */
		private var blok:BlokInfo;                           /* Блок вывода информации --- */
		private var rabFD:RabotaObjectDesign;
		private var tim1:Timer = new Timer(50, 0);           /* Таймер переноса блока информации --- */
		private var tim2:Timer = new Timer(50, 0);           /* Таймер изменения размеров блока информации --- */
		
		/* ТОЧКА ВХОДА ПРОЕКТА --------------------------------------------------------------------------------------------- */
		public function Main() {
		 /* Параметры полученные методом FlashVars ------------------------------------------------------------------------- */
			par = new DannyeFlashVars(loaderInfo.parameters);/* Параметры полученные из PHP-скрипта --- */			
			rabFD = new RabotaObjectDesign();                /* Объект для обращения в коде --- */
            this.osnovnoyFonZag();                           /* Создание основного фона и заголовка SWF --- */
		 /* Окрашивание объектов ------------------------------------------------------------------------------------------- */
		    this.klipNewColor();
		 /* Загрузка внешних файлов ---------------------------------------------------------------------------------------- */
			this.zagruzVnFile();
		 /* Загрузка XML-документа ----------------------------------------------------------------------------------------- */
			loadXML = new URLLoader();
			loadXML.addEventListener(Event.COMPLETE, zagruzXML);      /* Загрузка XML-документа --- */
			loadXML.load(new URLRequest("../components/com_kartarf/xml/" + par.xmldoc + ".xml?f=" + Math.floor(Math.random()*10000)));
		}
		
		/* Загрузка XML-документа и получение данных --- */		
		private function zagruzXML(e:Event):void{
	        var xml:XML = XML(loadXML.data);
	        var xmlList:XMLList = xml.children();
			var arrDk1:Array = new Array();
			var arrDk2:Array = new Array();
            for(var i:uint = 0; i < xmlList.length(); i++){
				if(i !== 21 && i !== 22 && i !== 55 && i !== 58){
					arrDk1.push(xmlList[i].toString());
				}else{
					if(i == 21) arrDk2[1] = xmlList[21].toString();
					if(i == 22) arrDk2[0] = xmlList[22].toString();
					if(i == 55) arrDk2[2] = xmlList[55].toString();
					if(i == 58) arrDk2[3] = xmlList[58].toString();
				}
	        }
			infRg = arrDk1;                                     /* Стат.массив данн.по суб.РФ кроме Мск и СПб из XML-докум. --- */
			infR2 = arrDk2;
			this.otrabotka();                                   /* Вызов основной функции, см.далее --- */
        }
		
        /* Работа по загрузке внешних файлов(в классе RabotaObjectDesign) --- */
		private function zagruzVnFile():void{
			/* Массив клипов vnF1 ... vnF7 --- */
			var zagrVnFl:Array = this.arrVneshnF;
			var zagrVnF2:Array = rabFD.zagruzVnFile(zagrVnFl);
			for(var i:int=0; i < zagrVnF2[0].length; i++){
				if(zagrVnF2[0][i] !== false) addChild(zagrVnF2[0][i]);
				if(zagrVnF2[1][i] !== false) addChild(zagrVnF2[1][i]);
			}
			addChild(blok);
		}

		/* Функция отработки после загрузки и получения данных XML-документа --- */
		private function otrabotka():void{
		 /* Задание значений статических свойств класса Main --- */
			var dann:DannyeProject = new DannyeProject();
			subRF = dann.sybjectRF;                             /* Статический массив клипов-субъектов РФ --- */
		    cenRF = dann.admCentryRF;                           /* Статический массив клипов-городов РФ --- */
		    krdGr = dann.koordGor;                              /* Статический массив список названий субъектов РФ --- */
			arrRg = this.arrRegiony;                            /* Статический массив - клипы-субъекты --- */
			arrGr = this.arrGoroda;                             /* Статический массив - клипы-города --- */
			arMSP = this.arrMskSPtb;                            /* Двумерн.массив по Москве и С-Петербургу --- */
			addChild(rescl);                                    /* Вывод кнопки rescl поверх блока информации --- */
		/* 0.Назв.города, 1.Назв.гор.для Мск и СПб, 2.Клип - осн.фон 3.Текст.поле в нижн.SWF,  4.Данн.Мск и СПб,
		   5.Клип обл.город Мск,СПб, 6.Данные по рег.Мск и СПб выводимые в информ.блок, 7.Информ.блок, 8.Цвет 
		   клипа-региона, 9.Цвет обводки клипа-региона, 10.Цвет клипа-города, 11.Фон карты-внешний файл */
			arObj = [txtG, txtG2, osnF, txtsub, arMSP, regMP, infR2, blok, par.cregfn, par.cregob, 
					 par.colgor, zagr];
			var reg:FunctionClip  = new FunctionClip(arObj);    /* Событийные функции клипов-объектов  --- */
			
			this.otrabotkaBlok();                               /* Перенос блока информации --- */
			this.resclBlok();                                   /* Изменение размеров блока информаци --- */
			this.minMaxBlok();                                  /* Сворачивание и разворачивание блока-инфо --- */
		}
		
		/* Перенос блока информации и следования за ним кнопки rescl --- */
		private function otrabotkaBlok():void{
			blok.blokZ.addEventListener(MouseEvent.MOUSE_DOWN, startBlok);
			blok.blokZ.addEventListener(MouseEvent.MOUSE_UP, stopBlok);
			blok.blZag.addEventListener(MouseEvent.MOUSE_DOWN, startBlok);
			blok.blZag.addEventListener(MouseEvent.MOUSE_UP, stopBlok);
			function startBlok(sob:MouseEvent):void{
	            blok.startDrag();
	            tim1.addEventListener(TimerEvent.TIMER, startKnop);
	            tim1.start();
            }
            function stopBlok(sob:MouseEvent):void{
	            blok.stopDrag();
	            tim1.stop();
             }
			 function startKnop(sob:TimerEvent):void{
				 rescl.x = blok.x + blok.width - 19;
				 rescl.y = blok.y + blok.height - 12;
			 }
		}
		
		/* Изменение размеров блока вывода информации клипом rescl --- */
		private function resclBlok():void{
			rescl.addEventListener(MouseEvent.MOUSE_DOWN, startResclBlok);
			rescl.addEventListener(MouseEvent.MOUSE_UP, stopResclBlok);
			function startResclBlok(sob:MouseEvent):void{
				rescl.startDrag();
				tim2.addEventListener(TimerEvent.TIMER, startKnopRescl);
				tim2.start();
			}
			function stopResclBlok(sob:MouseEvent):void{
				rescl.stopDrag();
				tim2.stop();
			}
			function startKnopRescl(sob:TimerEvent):void{
				var wBlok:Number = (rescl.x - blok.x) + rescl.width  + 5;
				var hBlok:Number = (rescl.y - blok.y) + rescl.height + 5;
				blok.razmerBlok(wBlok, hBlok);
			}
		}
		
		/* Сворачивание, разворачивание блока вывода информации --- */
		private function minMaxBlok():void{
			blok.blSvr.addEventListener(MouseEvent.MOUSE_UP, minmaxbloks);
			function minmaxbloks(sob:MouseEvent):void{
				if(blok.blSvr.ob.currentFrame == 1){
					blok.blSvr.ob.gotoAndStop(2);
					blHg = blok.height;
					blok.blInf.visible = false;
					blok.blScr.visible = false;
					rescl.visible = false;
					blok.razmerBlok(blok.width, 26);
				}else{
					if(blok.blSvr.ob.currentFrame == 2){
						blok.blSvr.ob.gotoAndStop(1);
						blok.blInf.visible = true;
					    blok.blScr.visible = true;
					    rescl.visible = true;
						blok.razmerBlok(blok.width, blHg);
						rescl.x = blok.x + blok.width - 20;
				        rescl.y = blok.y + blok.height - 13;
					}
				}
			}
		}
/* -------------------------------------------------------------------------------------------------------- */
        /* Массив кнопок над загружаемыми внешними файлами ------------------------------------------------ */
		private function get arrVneshnF():Array{
			var arrVnFile:Array = [vnF1, vnF2, vnF3, vnF4, vnF5, vnF6, vnF7];
			return arrVnFile;
		}
        /* Массив данных регионов Москвы и С-Петербурга --------------------------------------------------- */
		private function get arrMskSPtb():Array{
			var arrMsSP:Array = new Array ();
			var col1:Number = par.colnza;
			var col2:Number = par.colnzb;
		 /* 0.Клип-регион, 1.Влож.клип-фон, 2.Влож.клип-обв, 3.Клип-город, 4.Бл.выбора-X, 
			5.Бл.выбора-Y, 6.Назв.гор-X, 7.Назв.гор-Y, 8.Город, 9.Область */
			arrMsSP[0] = [kl_47, kl_47.fn47, kl_47.ob47, gt_47, 115, 132, 160, 
						  140, "Санкт-Петербург", "Ленинградская обл.", col2]; 
		    arrMsSP[1] = [kl_50, kl_50.fn50, kl_50.ob50, gt_50, 105, 186, 140, 
						  198, "Москва", "Московская область", col1];
			return arrMsSP;
		}
		/* Массив клипов-регионов, админ.центров России без Москвы и С-Петербурга ------------------------- */
		private function get arrRegiony():Array {
			var arrReg0:Array = new Array (
	            kl_1,  kl_2,  kl_3,  kl_4,  kl_5,  kl_6,  kl_7,  kl_8,  kl_9, kl_10,
	           kl_11, kl_12, kl_13, kl_14, kl_15, kl_16, kl_17, kl_18, kl_19,
	           kl_21, kl_95, kl_22, kl_75, kl_41, kl_23, kl_24, kl_59, kl_25, kl_26,
	           kl_27, kl_83, kl_86, kl_87, kl_89, kl_28, kl_29, kl_30, kl_31, kl_32,
	           kl_33, kl_34, kl_35, kl_36, kl_79, kl_37, kl_38, kl_39, kl_40, kl_42,
	           kl_43, kl_44, kl_45, kl_46, kl_48, kl_49, kl_51, kl_52,
	           kl_53, kl_54, kl_55, kl_56, kl_57, kl_58, kl_60, kl_61, kl_62, kl_63,
	           kl_64, kl_65, kl_66, kl_67, kl_68, kl_69, kl_70,
	           kl_71, kl_72, kl_73, kl_74, kl_76
            );
			return arrReg0;
		}
		/* Массив клипов-обводок регионов без Москвы и С-Петербурга --- */
		private function get arrRegObv():Array {
			var arrRegObv:Array = new Array (
	             kl_1.ob1,   kl_2.ob2,   kl_3.ob3,   kl_4.ob4,   kl_5.ob5,   kl_6.ob6,
				 kl_7.ob7,   kl_8.ob8,   kl_9.ob9, kl_10.ob10, kl_11.ob11, kl_12.ob12, 
			   kl_13.ob13, kl_14.ob14, kl_15.ob15, kl_16.ob16, kl_17.ob17, kl_18.ob18, 
			   kl_19.ob19, kl_21.ob21, kl_95.ob95, kl_22.ob22, kl_75.ob75, kl_41.ob41, 
			   kl_23.ob23, kl_24.ob24, kl_59.ob59, kl_25.ob25, kl_26.ob26, kl_27.ob27, 
			   kl_83.ob83, kl_86.ob86, kl_87.ob87, kl_89.ob89, kl_28.ob28, kl_29.ob29, 
			   kl_30.ob30, kl_31.ob31, kl_32.ob32, kl_33.ob33, kl_34.ob34, kl_35.ob35, 
			   kl_36.ob36, kl_79.ob79, kl_37.ob37, kl_38.ob38, kl_39.ob39, kl_40.ob40, 
			   kl_42.ob42, kl_43.ob43, kl_44.ob44, kl_45.ob45, kl_46.ob46, kl_48.ob48, 
			   kl_49.ob49, kl_51.ob51, kl_52.ob52, kl_53.ob53, kl_54.ob54, kl_55.ob55, 
			   kl_56.ob56, kl_57.ob57, kl_58.ob58, kl_60.ob60, kl_61.ob61, kl_62.ob62, 
			   kl_63.ob63, kl_64.ob64, kl_65.ob65, kl_66.ob66, kl_67.ob67, kl_68.ob68, 
			   kl_69.ob69, kl_70.ob70, kl_71.ob71, kl_72.ob72, kl_73.ob73, kl_74.ob74, 
			   kl_76.ob76, kl_47.ob47, kl_50.ob50
            );
			return arrRegObv;
		}
		/* Массив клипов-обводок регионов без Москвы и С-Петербурга --- */
		private function get arrRegFon():Array {
			var arrRegFon:Array = new Array (
	             kl_1.fn1,   kl_2.fn2,   kl_3.fn3,   kl_4.fn4,   kl_5.fn5,   kl_6.fn6,
				 kl_7.fn7,   kl_8.fn8,   kl_9.fn9, kl_10.fn10, kl_11.fn11, kl_12.fn12, 
			   kl_13.fn13, kl_14.fn14, kl_15.fn15, kl_16.fn16, kl_17.fn17, kl_18.fn18, 
			   kl_19.fn19, kl_21.fn21, kl_95.fn95, kl_22.fn22, kl_75.fn75, kl_41.fn41, 
			   kl_23.fn23, kl_24.fn24, kl_59.fn59, kl_25.fn25, kl_26.fn26, kl_27.fn27, 
			   kl_83.fn83, kl_86.fn86, kl_87.fn87, kl_89.fn89, kl_28.fn28, kl_29.fn29, 
			   kl_30.fn30, kl_31.fn31, kl_32.fn32, kl_33.fn33, kl_34.fn34, kl_35.fn35, 
			   kl_36.fn36, kl_79.fn79, kl_37.fn37, kl_38.fn38, kl_39.fn39, kl_40.fn40, 
			   kl_42.fn42, kl_43.fn43, kl_44.fn44, kl_45.fn45, kl_46.fn46, kl_48.fn48, 
			   kl_49.fn49, kl_51.fn51, kl_52.fn52, kl_53.fn53, kl_54.fn54, kl_55.fn55, 
			   kl_56.fn56, kl_57.fn57, kl_58.fn58, kl_60.fn60, kl_61.fn61, kl_62.fn62, 
			   kl_63.fn63, kl_64.fn64, kl_65.fn65, kl_66.fn66, kl_67.fn67, kl_68.fn68, 
			   kl_69.fn69, kl_70.fn70, kl_71.fn71, kl_72.fn72, kl_73.fn73, kl_74.fn74, 
			   kl_76.fn76, kl_47.fn47, kl_50.fn50
            );
			return arrRegFon;
		}
		/* Массив клипов-городов, админ.центров России без Москвы и С-Петербурга --- */
		private function get arrGoroda():Array {
			var arrGor0:Array = new Array (
	            gt_1,  gt_2,  gt_3,  gt_4,  gt_5,  gt_6,  gt_7,  gt_8,  gt_9, gt_10,
	           gt_11, gt_12, gt_13, gt_14, gt_15, gt_16, gt_17, gt_18, gt_19,
	           gt_21, gt_95, gt_22, gt_75, gt_41, gt_23, gt_24, gt_59, gt_25, gt_26,
	           gt_27, gt_83, gt_86, gt_87, gt_89, gt_28, gt_29, gt_30, gt_31, gt_32,
	           gt_33, gt_34, gt_35, gt_36, gt_79, gt_37, gt_38, gt_39, gt_40, gt_42,
	           gt_43, gt_44, gt_45, gt_46, gt_48, gt_49, gt_51, gt_52,
	           gt_53, gt_54, gt_55, gt_56, gt_57, gt_58, gt_60, gt_61, gt_62, gt_63,
	           gt_64, gt_65, gt_66, gt_67, gt_68, gt_69, gt_70,
	           gt_71, gt_72, gt_73, gt_74, gt_76
            );
			return arrGor0;
		}
		/* Вывод основного фона(зад.новых разм.клипа osnF и общий фон-рисунок) и заголовка SWF-файла ------- */		
        private function osnovnoyFonZag():void{
			/* Заливка фона SWF-файла --- */
			var koordX:Number = (900 - par.vntrwd)/2;
			this.graphics.beginFill(par.colswf);                     
            this.graphics.drawRect( koordX, 0, int(par.vntrwd), 600);
            this.graphics.endFill();
			osnF.width = 900;
			osnF.height = 600;
			if(par.swfobh !== ""){
				var request:URLRequest = new URLRequest(par.swfobh); 
                this.zagr = new Loader(); 
                zagr.load(request);
				setChildIndex(addChild(zagr), 1);
				osnF.alpha = 0;
			}
			txtzag.text = par.swfzag;
			txtzag.textColor = par.colzag;
			txtsub.textColor = par.colsub;
		}
		/* Окрашивание объектов ---------------------------------------------------------------------------- */
		/* Помимо окрашивания уже созданных объектов в этой функции создаётся экземпляр блока 
		   вывода информации(для его окрашивания), а перед этим создаётся текстовое поле вывода 
		   названия города админ-центра. Окрашивание части объектов происходит в экземпляре
		   класса RabotaObjectDesign */
		private function klipNewColor():void{
			var arrObv:Array = this.arrRegObv;
			var arrReg:Array = this.arrRegFon;
			var arrGor:Array = this.arrGoroda;
			arrGor.push(gt_47);
		 /* 0.Осн.фон, 1.Карта-подложка, 2.Коорд.сетка, 3.Кнока rescl, 4.Клипы-регионы(обводка),
			5.Клипы-регионы(фон), 6.Клипы-города -------------------------------------------- */
			var newCol = [osnF, osnK, osnS, rescl, arrObv, arrReg, arrGor, regMP, ozera];
			rabFD.klipNewColor(newCol);
			regMP.visible = false;
			this.txtG = new TextField();                   /* Текст.поле назв.города-адм.центра(НЕ Мск и СПб) --- */
			addChild(txtG);
			this.txtG2 = new TextField();                  /* Текст.поле назв.города-адм.центра(Мск и СПб) --- */
			addChild(txtG2);
			/* Окрашивание инфо-блока --- */
			blok = new BlokInfo();                         /* Блок вывода информации --- */
		    /* Цвет: 0.общий фон блока, 1.фон загол., 2.текст заголовка в блоке 3.Обводка */
			var newColInfo:Array = [par.blobsf, par.blzagf, par.blzagt, par.blcobv];
			blok.newColorBlok(newColInfo);
		}
	}
}
