﻿package doc_as {
	
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFieldType;
	import flash.text.TextFieldAutoSize;
	import flash.geom.ColorTransform;
	import flash.display.Loader;
	
	public class FunctionClip {
		
		private var arrSm:Array    = new Array();           /* Сборн.массив объектов и данн.(без Москвы и С-Петербурга) */
		private var arMSP:Array    = new Array();           /* Сборн.массив объектов и данн.по Москве и С-Петербургу */
		private var regMP:MovieClip;                        /* Блок область-город для Москвы и С-Петербурга --- */
		private var infR2:Array;                            /* Информ.вывод.в инф.блок по Мск и СПб --- */
		private var txtG:TextField  = new TextField();      /* Отображает название города --- */
		private var txtG2:TextField = new TextField();      /* Отображает название города Мск и СПб --- */
		private var txtsub:TextField;                       /* Текст.поле вывода суб.РФ в нижн.части SWF --- */
		private var klNm:int;                               /* Работает при клике по txtG(названию города) --- */
		private var rMSP:int;                               /* Работает при клике в блоке выбора Мск и СПб --- */
		private var blok:MovieClip;                         /* Блок вывода информации --- */
		private var osnF:MovieClip;                         /* Клип, основной фон-подложка SWF --- */
		private var cfon:Number;                            /* Цвет осн.фона клипа-рег. --- */
		private var cobv:Number;                            /* Цвет обводки клипа-рег. --- */
		private var cgor:Number;                            /* Цвет клипа-города --- */
		private var colTr:ColorTransform;                   /* Окрашивание клипов --- */
		private var zagr:Loader;                            /* Отображает общий фон карты-внешний файл --- */
        
		/* Аргументы: 1.Текстовое поле вывода названия города --- */
		public function FunctionClip(arg1:Array) {
			this.txtG   = arg1[0];
			this.txtG2  = arg1[1];
			this.osnF   = arg1[2];
			this.txtsub = arg1[3];
			this.arMSP  = arg1[4];
			this.regMP  = arg1[5];
			this.infR2  = arg1[6];
			this.blok   = arg1[7];
			this.cfon   = arg1[8];
			this.cobv   = arg1[9];
			this.cgor   = arg1[10];
			this.zagr   = arg1[11];
		 /* Для компактности собираем все необходимые равноразмерные массивы в один. Аргумены:
		    0.Клипы-регионы, 1.Клипы города, 2.Список субъектов РФ, 3.Список центров субъектов РФ,
			4.Двумерный массив координат вывода текстового поля названия города, 5.Массив выводимых 
			данных в блоке --- */
			this.arrSm = [Main.arrRg, Main.arrGr, Main.subRF, Main.cenRF, Main.krdGr, Main.infRg];
	    /* Вызов функций --- */
		    this.navedOsnFon();
			this.clipyMouseOver();
			this.clipyMouseOut();
			this.clipyMouseUp();
			this.clipyMouseOver2();
			this.clipyMouseOut2();
			this.regMPOver();
		}
	/* -------------------------------------------------------------------------------------------------------- */		
		/* Функции блока regMP --- */
		    private function regMPOver():void{
				regMP.addEventListener(MouseEvent.MOUSE_OVER, regMPOv);
				function regMPOv(sob:MouseEvent):void{
					regMP.visible = true;
					txtG2.visible = true;
					arMSP[rMSP][0].alpha = 0;
				}
				/* Клик по названию области --- */
				regMP.txObl.addEventListener(MouseEvent.MOUSE_UP, regMPOblast);
				function regMPOblast():void{
					vyvodInfoBlok(arMSP[rMSP][9], infR2[rMSP + 2]);
				}
				/* Клик по названию города --- */
			    regMP.txGor.addEventListener(MouseEvent.MOUSE_UP, regMPGorod);
				function regMPGorod():void{
					vyvodInfoBlok("г. " + arMSP[rMSP][8], infR2[rMSP]);
				}
			}
	/* -------------------------------------------------------------------------------------------------------- */
	    /* Функции клипов-регионов МОСКВЫ и С-ПЕТЕРБУРГА --- */
		private function clipyMouseOver2():void{
			for(var i:uint=0; i < arMSP.length; i++){
				clipMousOv2(i);
			}
			function clipMousOv2(arg1:int):void{
				arMSP[arg1][0].addEventListener(MouseEvent.MOUSE_OVER, regionMousOver2);
				arMSP[arg1][3].addEventListener(MouseEvent.MOUSE_OVER, regionMousOver2);
				function regionMousOver2(sob:MouseEvent):void{
					rMSP = arg1;
					clipAlpha1();
					txtG.visible = false;
					txtG2.visible = true;
					arMSP[arg1][0].alpha = 0;
				    regMP.visible = true;
				    regMP.x     = arMSP[arg1][4];
				    regMP.y     = arMSP[arg1][5];
				    regMP.txObl.text = arMSP[arg1][9];
				    regMP.txGor.text = "г." + arMSP[arg1][8];
					txtGorod(txtG2, arMSP[arg1][8], arMSP[arg1][6], arMSP[arg1][7], arMSP[arg1][10]);
					txtGorodOvOut2(arg1);
				}
			}
		}
		private function clipyMouseOut2():void{
			for(var i:uint=0; i < arMSP.length; i++){
				clipMousOt2(i);
			}
			function clipMousOt2(arg1:int):void{
				arMSP[arg1][0].addEventListener(MouseEvent.MOUSE_OUT, regionMousOut2);
				arMSP[arg1][3].addEventListener(MouseEvent.MOUSE_OUT, regionMousOut2);
				function regionMousOut2(sob:MouseEvent):void{
					clipAlpha1();
				}
			}
		}
	/* -------------------------------------------------------------------------------------------------------- */	
	    /* Удаление видимости объектов при наведении на основной фон --- */
	    private function navedOsnFon():void{
			osnF.addEventListener(MouseEvent.MOUSE_OVER, navosnfon);
			if(Main.par.swfobh !=="")
			zagr.addEventListener(MouseEvent.MOUSE_OVER, navosnfon);
			function navosnfon(sob:MouseEvent):void{
				txtG.visible = false;
				txtG2.visible = false;
				regMP.visible = false;
				clipAlpha2();
			}
		}
	/* -------------------------------------------------------------------------------------------------------- */	
	    /* Функции клипов-регионов БЕЗ МОСКВЫ и С-ПЕТЕРБУРГА --- */
	    /* Функции клика по клипу-региону --- */
		private function clipyMouseUp():void{
			for(var i:int = 0; i < arrSm[0].length; i++){
				clipMousUp(i);
			}
			function clipMousUp(arg1:int):void{
				arrSm[0][arg1].addEventListener(MouseEvent.MOUSE_UP, regionMousUp);
				Main.arrGr[arg1].addEventListener(MouseEvent.MOUSE_UP, regionMousUp);
				function regionMousUp(sob:MouseEvent):void{
					vyvodInfoBlok(arrSm[2][arg1], arrSm[5][arg1]);
				}
			}
		}
		/* Вывод текста из XML-документа в блок информации --- */
		private function vyvodInfoBlok(arg1:String, arg2:String):void{
			txtsub.text = arg1;
			blok.blZag.text = arg1;
			var patt:RegExp = /\r\n/g;
			arg2 = arg2.replace(patt, "\n");  
			blok.blInf.htmlText = znachInfoRegion(arg2);
			blok.blInf.scrollV = 1;
			blok.blScr.scrollTarget = blok.blInf;
		}
		
		/* Присвоение значения текстовому полю в блоке инфо --- */
		private function znachInfoRegion(arg1:String):String{
			var patt:RegExp = /\r\n/g;
			var strB:String = arg1.replace(patt, "\n");
			var str0:String = "<font color=\'#" + Main.par.bltxtb 
			    + "\' size='" + Math.round(11/Main.par.coeffh) + "\'>";
			var str1:String = "</font>";
			strB = str0 + strB + str1;
			return strB;
		}
		/* Функции наведения курсора мыши на клип-регион --- */
		private function clipyMouseOver():void{
			txtG.addEventListener(MouseEvent.MOUSE_UP, regionMousUp1);
			for(var i:int = 0; i < arrSm[0].length; i++){
				clipMousOv(i);
			}
			function clipMousOv(arg1:int):void{
				arrSm[0][arg1].addEventListener(MouseEvent.MOUSE_OVER, regionMousOver);
				Main.arrGr[arg1].addEventListener(MouseEvent.MOUSE_OVER, regionMousOver);
				function regionMousOver(sob:MouseEvent):void{
					txtG.visible = true;
					regMP.visible = false;         /* Невидимость блока обл.город Мск и СПб */
					txtG2.visible = false;         /* Невидимость вывода названия Мск и СПб */
					clipAlpha1();
					clipAlpha2();
				    arrSm[0][arg1].alpha = 0;
					txtGorod(txtG, arrSm[3][arg1], arrSm[4][arg1][0], arrSm[4][arg1][1], Main.par.colnam[arg1]);
					txtGorodOvOut(arg1);
			    }
			}
		}
		/* Функции увода курсора мыши с клипа-региона --- */
		private function clipyMouseOut():void{
			for(var i:int = 0; i < arrSm[0].length - 2; i++){
				clipMousOt(i);
			}
			function clipMousOt(arg1:int):void{
				arrSm[0][arg1].addEventListener(MouseEvent.MOUSE_OUT, regionMousOut);
				function regionMousOut(sob:MouseEvent):void{
					arrSm[0][arg1].alpha = 1;
				}
			}
		}
	    /* Функция клика по названию города(txtG) --- */
		private function regionMousUp1(sob2:MouseEvent):void{
			txtsub.text = arrSm[2][klNm];
			blok.blZag.text = arrSm[2][klNm];
			blok.blInf.htmlText = znachInfoRegion(arrSm[5][klNm]);
			blok.blInf.scrollV = 1;
		    blok.blScr.scrollTarget = blok.blInf;
		}
	/* -------------------------------------------------------------------------------------------------------- */
		/* Задание свойств текстового поля-названия города(для всех регионов РФ) --- */
		private function txtGorod(arg1:TextField, arg2:String, arg3:Number, arg4:Number, arg5:int):void{
			var vrem:TextFormat = new TextFormat();
			arg1.type = TextFieldType.DYNAMIC;
			arg1.autoSize = TextFieldAutoSize.LEFT;
			arg1.selectable = false;
			arg1.multiline = false;
			arg1.text = arg2;
			vrem.font = "Arial";
			vrem.size = 11/Main.par.coeffh;
            vrem.bold = true;
            vrem.color = arg5;
			arg1.setTextFormat(vrem);
			arg1.x = arg3;
			arg1.y = arg4;
		}
		/* События txtG для регионов кроме Мск и СПб --- */
		private function txtGorodOvOut(arg1:int){
			txtG.addEventListener(MouseEvent.MOUSE_OVER, regionMousOver1a);
			txtG.addEventListener(MouseEvent.MOUSE_OUT, regionMousOut1a);
			function regionMousOver1a(sob:MouseEvent):void{
				clipAlpha1();
				arrSm[0][arg1].alpha = 0;
				klNm = arg1;
			}
			function regionMousOut1a(sob:MouseEvent):void{
				arrSm[0][arg1].alpha = 1;
			}
        }
		/* События txtG2 для регионов Мск и СПб --- */
		private function txtGorodOvOut2(arg1:int){
			txtG2.addEventListener(MouseEvent.MOUSE_OVER, regionMousOver2a);
			txtG2.addEventListener(MouseEvent.MOUSE_OUT, regionMousOut2a);
			function regionMousOver2a(sob:MouseEvent):void{
				clipAlpha1();
				arMSP[rMSP][0].alpha = 0;
			}
			function regionMousOut2a(sob:MouseEvent):void{
				arMSP[rMSP][0].alpha = 1;
				txtG2.visible = false;
			}
        }
	/* -------------------------------------------------------------------------------------------------------- */
		/* Присв.плотн. == 1 всему набору клипов кроме Мск и СПб. --- */
		private function clipAlpha1():void{
			for(var i:uint=0; i < arrSm[0].length; i++){
				arrSm[0][i].alpha = 1;
			}
		}
		/* Присв.плотн. == 1 набору клипов Мск и СПб. --- */
		private function clipAlpha2():void{
			arMSP[0][0].alpha = 1;
			arMSP[1][0].alpha = 1;
		}
	}
}