﻿package doc_as {
	
	import flash.display.*;
	import flash.display.Loader;
	import flash.geom.ColorTransform;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	
	public class RabotaObjectDesign {
		
		private var par:DannyeFlashVars;               /* Параметры полученные из PHP-скрипта --- */
		private var parV:Array;
        private var zagr:Loader;
		
		public function RabotaObjectDesign() {
			this.par = Main.par;
			this.parV = [par.bannra, par.bannrb, par.bannrc, par.bannrd, 
							  par.bannre, par.bannrf, par.bannrg];
		}
		
		/* Работа по загрузке внешних файлов и получение массива кнопок для которых задана ссылка 
		   в качестве аргумента передаётся массив кнопок vnF1 ... vnF7 */
		public function zagruzVnFile(arg1:Array):Array{
		/* Определение событийных функций кнопок vnF1 ... vnF7 --- */
			for(var i:int = 0; i < arg1.length; i++){
				knopMousUp(i);
			}
			function knopMousUp(arg2:int):void{
				arg1[arg2].addEventListener(MouseEvent.MOUSE_UP, perehodSsylka);
				function perehodSsylka(sob:MouseEvent):void{
					if(parV[arg2] !== "" && parV[arg2] !== "undefined"){
					    var rez0:Array = parV[arg2].split("|");
						if(String(rez0[1]) !== "undefined"){
							var nach:String = String(rez0[1]).slice(0, 7);
							if(nach == "http://"){  /* Второй параметр - URL-ссылка --- */
								var urlSsylka:URLRequest=new URLRequest(rez0[1]);
								if(String(rez0[2]) !== "undefined") navigateToURL(urlSsylka, rez0[2]);
	                            if(String(rez0[2]) == "undefined") navigateToURL(urlSsylka);
							}
							if(nach == "mailto:"){  /* Второй параметр - адрес e-mail --- */
								var pismo:URLRequest = new URLRequest(rez0[1]);
                                navigateToURL(pismo, "_blank");
							}
						}
					}
				}
			}
		/* Загрузка внешних файлов, определение кнопок над внешними файлами которым задан параметр перехода
		   и формирование передаваемого в класс Main двумерного массива для addChild --- */
			var rez1:Array = new Array()
			rez1[0] = new Array();   /* Принимает загрузчики или false --- */
			rez1[1] = new Array();   /* Принимает кнопку vnF1...vnF7 для addChild или false --- */
			for(i = 0; i < arg1.length; i++){
				arg1[i].alpha = 0;
				if(parV[i] !== "" && parV[i] !== "undefined"){
					var urlStr:Array = new Array();
					urlStr = String(parV[i]).split("|");
					/* Загружаем внешний файл --- */
					var request:URLRequest = new URLRequest(urlStr[0]); 
                    var zagr:Loader = new Loader(); 
                    zagr.load(request); 
					zagr.x = arg1[i].x;
					zagr.y = arg1[i].y;
					rez1[0][i] = zagr;
					if(String(urlStr[1]) !== "undefined"){
						rez1[1][i] = arg1[i];
					}else{
						arg1[i].visible = false;
						rez1[1][i] = false;
					}
				}else{
					arg1[i].visible = false;
					rez1[0][i] = false;
					rez1[1][i] = false;
				}
			}
			return rez1;
		}
		
		/* Окрашивание клипов проекта созданных в режиме дизайна --- */
		public function klipNewColor(arg1:Array):void{
			var colTr:ColorTransform = new ColorTransform();
			colTr.color = par.colswf;                           /* Окрашивание основного фона --- */
			arg1[0].transform.colorTransform = colTr;
			colTr.color = par.colpdl;                           /* Окрашивание карты-подложки --- */
			arg1[1].transform.colorTransform = colTr;
			colTr.color = par.colset;                           /* Окрашивание координатной сетки --- */
			arg1[2].setK.transform.colorTransform = colTr;
			colTr.color = par.colbrd;
			arg1[2].obvK.transform.colorTransform = colTr;
			arg1[2].alpha  = par.alpset;
			colTr.color = par.blcobv;                           /* Окрашивание кнопки rescl --- */
			arg1[3].transform.colorTransform = colTr;
			colTr.color = par.colozr;                           /* Окрашивание озёр --- */
			arg1[8].transform.colorTransform = colTr;
			colTr.color = par.cregob;                           /* Окрашивание обводки регионов --- */
			for(var i:int; i < arg1[4].length; i++){
				arg1[4][i].transform.colorTransform = colTr;
			}
			colTr.color = par.cregfn;                           /* Окрашивание общего фона регионов --- */
			for(i=0; i < arg1[5].length; i++){
				arg1[5][i].transform.colorTransform = colTr;
			}
			colTr.color = par.colgor;                           /* Окрашивание клипов-городов --- */
			for(i=0; i < arg1[6].length; i++){
				arg1[6][i].transform.colorTransform = colTr;
			}
			colTr.color = par.blobsf;                           /* Окрашивание блока Мск-СПб --- */
			arg1[7].osnMP.transform.colorTransform = colTr;
			colTr.color = par.blcobv;
			arg1[7].obvMP.transform.colorTransform = colTr;
			arg1[7].txObl.textColor = Number("0x" + par.bltxtb);
			arg1[7].txGor.textColor = Number("0x" + par.bltxtb);
		}
	}
}
