<?php
defined('_JEXEC') or die;
jimport('joomla.application.component.modelitem');

/* Модель сообщения компонента KartaRF */
class KartaRFModelKartaRF extends JModelItem
{
	/* Сообщение */
	protected $item;

	/* Возвращает ссылку на объект таблицы */
	public function getTable($type = 'KartaRF', $prefix = 'KartaRFTable', $config = array()) 
	{
		return JTable::getInstance($type, $prefix, $config);
	}

	/* Получаем сообщение */
	public function getItem() 
	{
		if (!isset($this->item)) 
		{
			$id = $this->getState('message.id');

			/* Конструируем SQL запрос */
			$this->_db->setQuery($this->_db->getQuery(true)
					->select('h.swfwdt, h.swfhgt, h.swfzag, h.swfobh, h.bannra, h.bannrb, h.bannrc, h.bannrd, h.bannre, h.bannrf, 
					          h.bannrg, h.xmldoc, h.colswf, h.colbrd, h.colset, h.alpset, h.colzag, h.colsub, h.colpdl, h.colozr, 
							  h.cregfn, h.cregob, h.colgor, h.colnza, h.colnzb, h.blobsf, h.blzagf, h.blzagt, h.bltxtb, h.blcobv, 
							  h.editra, h.editrb, h.subj01, h.subj02, h.subj03, h.subj04, h.subj05, h.subj06, h.subj07, h.subj08, 
							  h.subj09, h.subj10, h.subj11, h.subj12, h.subj13, h.subj14, h.subj15, h.subj16, h.subj17, h.subj18, 
							  h.subj19, h.subj21, h.subj95, h.subj77, h.subj78, h.subj22, h.subj75, h.subj41, h.subj23, h.subj24, 
							  h.subj59, h.subj25, h.subj26, h.subj27, h.subj83, h.subj86, h.subj87, h.subj89, h.subj28, h.subj29, 
							  h.subj30, h.subj31, h.subj32, h.subj33, h.subj34, h.subj35, h.subj36, h.subj79, h.subj37, h.subj38, 
							  h.subj39, h.subj40, h.subj42, h.subj43, h.subj44, h.subj45, h.subj46, h.subj47, h.subj48, h.subj49, 
							  h.subj50, h.subj51, h.subj52, h.subj53, h.subj54, h.subj55, h.subj56, h.subj57, h.subj58, h.subj60, 
							  h.subj61, h.subj62, h.subj63, h.subj64, h.subj65, h.subj66, h.subj67, h.subj68, h.subj69, h.subj70, 
							  h.subj71, h.subj72, h.subj73, h.subj74, h.subj76, c.title as category')
					->from('#__kartarf as h')
					->leftJoin('#__categories as c ON h.catid=c.id')
					->where('h.id=' . (int)$id));

			if (!$this->item = $this->_db->loadObject()) 
			{
				$this->setError($this->_db->getError());
			}
			else
			{
				/* Загружаем JSON строку параметров */
				$params = new JRegistry;
				$params->loadString($this->item->params);
				$this->item->params = $params;
 				/* Объединяем глобальные параметры с индивидуальными */
				$params = clone $this->getState('params');
				$params->merge($this->item->params);
				$this->item->params = $params;
				/* Формирование строки переменных FlashVars */
				$this->item->strFlVar = $this->strokaFlashVars($this->item);
                /* Создание XML-документа */
				$arrReg = $this->arrReguony($this->item);   /* Массив даныых по регионам */
                $this->xmlDocument($arrReg, $this->item->xmldoc);				
			}
		}
		return $this->item;
	}
	
	/* Функция получения массива формирования XML-документа */
	private function arrReguony($dann)
	{
	    $rez = array (
		    $dann->subj01, $dann->subj02, $dann->subj03, $dann->subj04, $dann->subj05, $dann->subj06, $dann->subj07,
			$dann->subj08, $dann->subj09, $dann->subj10, $dann->subj11, $dann->subj12, $dann->subj13, $dann->subj14,
			$dann->subj15, $dann->subj16, $dann->subj17, $dann->subj18, $dann->subj19, $dann->subj21, $dann->subj95,
			$dann->subj77, $dann->subj78, $dann->subj22, $dann->subj75, $dann->subj41, $dann->subj23, $dann->subj24,
			$dann->subj59, $dann->subj25, $dann->subj26, $dann->subj27, $dann->subj83, $dann->subj86, $dann->subj87,
			$dann->subj89, $dann->subj28, $dann->subj29, $dann->subj30, $dann->subj31, $dann->subj32, $dann->subj33,
			$dann->subj34, $dann->subj35, $dann->subj36, $dann->subj79, $dann->subj37, $dann->subj38, $dann->subj39,
			$dann->subj40, $dann->subj42, $dann->subj43, $dann->subj44, $dann->subj45, $dann->subj46, $dann->subj47,
			$dann->subj48, $dann->subj49, $dann->subj50, $dann->subj51, $dann->subj52, $dann->subj53, $dann->subj54,
			$dann->subj55, $dann->subj56, $dann->subj57, $dann->subj58, $dann->subj60, $dann->subj61, $dann->subj62,
			$dann->subj63, $dann->subj64, $dann->subj65, $dann->subj66, $dann->subj67, $dann->subj68, $dann->subj69,
			$dann->subj70, $dann->subj71, $dann->subj72, $dann->subj73, $dann->subj74, $dann->subj76
		);
		return $rez;
	}
	
	/* Функция формирования XML-документа */
	private function xmlDocument($dann, $strxml)
	{
	    $str = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<kartarf>\n";
		for($i = 0; $i < count($dann); $i++)
		{
		    $str .= "    <region>" . htmlspecialchars($dann[$i], ENT_QUOTES) . "</region>\n";
		}
		$str .= "</kartarf>";
		$path = "components/com_kartarf/xml/" . $strxml . ".xml";
        $fp   = fopen($path, 'w');
        $fw   = fwrite($fp, $str);
        fclose($fp);
	}
	/* Функция получения строки FlashVars, переменных передаваемых в SWF-файл */
	private function strokaFlashVars($dann)
	{
		$rez = 'swfzag='.$dann->swfzag.'&bannra='.$dann->bannra.'&bannrb='.$dann->bannrb.'&bannrc='.$dann->bannrc.
		      '&bannrd='.$dann->bannrd.'&colswf='.$dann->colswf.'&colset='.$dann->colset.'&alpset='.$dann->alpset. 
			  '&colzag='.$dann->colzag.'&colsub='.$dann->colsub.'&colpdl='.$dann->colpdl.'&cregfn='.$dann->cregfn.
			  '&cregob='.$dann->cregob.'&colgor='.$dann->colgor.'&colnza='.$dann->colnza.'&colnzb='.$dann->colnzb.
			  '&blobsf='.$dann->blobsf.'&blzagf='.$dann->blzagf.'&blzagt='.$dann->blzagt.'&bltxtb='.$dann->bltxtb.
			  '&xmldoc='.$dann->xmldoc.'&swfobh='.$dann->swfobh.'&bannre='.$dann->bannre.'&bannrf='.$dann->bannrf.
			  '&bannrg='.$dann->bannrg.'&colbrd='.$dann->colbrd.'&colozr='.$dann->colozr.'&blcobv='.$dann->blcobv;
        return $rez;
	}	

	/* Метод для авто-заполнения состояния модели */
	protected function populateState() 
	{
		$app = JFactory::getApplication();

		/* Получаем Id сообщения из Запроса */
		$id = $app->input->getInt('id');

		/* Добавляем Id сообщения в состояние модели */
		$this->setState('message.id', $id);

		/* Загружаем глобальные параметры */
		$params = $app->getParams();

		/* Добавляем параметры в состояние модели */
		$this->setState('params', $params);

		parent::populateState();
	}
}